#include <bits/stdc++.h>
using namespace std;

int brojiIzmene(string s)
{
    int n = s.length();
    bool ini = false;

    int cnt = 0;

    for (int i = 0; i < n / 2; i++) {
        int levo = i;
        int desno = n - levo - 1;

        while (levo < desno) {
            if (s[levo] == s[desno]) {
                break;
            }
            else {
                desno--;
            }
        }

        if (levo == desno) {
            return -1;
        }

        for (int j = desno; j < n - levo - 1; j++) {
            if(ini == false){
                cnt = n - levo - j;
                ini = true;
            }
            swap(s[j], s[j + 1]);
        }
    }

    if(cnt == 0)
        return cnt+1;
    else
        return cnt;
}

int main()
{
    string s;
    cin>>s;

    int odg1 = brojiIzmene(s);

    reverse(s.begin(), s.end());
    int odg2 = brojiIzmene(s);

    cout << max(odg1, odg2);

    return 0;
}